Unit afg5e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTAFSI_p;

procedure afg5e(var A :Array of Extended; M :Integer; N :Integer;
                var NLEAD :Array of Integer; var IERR :Integer);

implementation

procedure afg5e(var A :Array of Extended; M :Integer; N :Integer;
                var NLEAD :Array of Integer; var IERR :Integer);
var
I,J,JJ,K,KP1,L,NM11,NM1 :Integer;
T,X :Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200;
begin
{ ******************************************************************** }
{   LU-                         }
{                                             }
{                                                                      }
{   -  (:INGR)                                 }
{   N- (:INGR)                                      }
{   - *N,    ,                  }
{                      }
{    U     INVRS(L)(:RL)  }
{   NLD-  N,   ,         }
{    (:INGR)                                  }
{   IRR-,  (:INGR)            }
{                                                                      }
{ ******************************************************************** }

{        }
X := 0.0e0;
_10:

{         N }
if ( N >= 1 ) and ( M >= 1 ) 
 then goto _20;
IERR := 65;
UTAFSI('A','F','G','5','E',IERR);
goto _200;
_20:
IERR := 0;
NM1 := N - 1;
if ( NM1 < 1 ) 
 then goto _190;
for K:=1 to NM1 do
 begin
  KP1 := K + 1;

{       L }
  L := K;
  T := Abs(A[(K-1)+(K-1)*M]);
  for J:=KP1 to N do
   begin
    if ( Abs(A[(J-1)+(K-1)*M]) <= T ) 
     then goto _30;
    L := J;
    T := Abs(A[(J-1)+(K-1)*M]);
_30:
_40:
   end;
  NLEAD[K-1] := L;
{             IF ((L,) .Q. 0.0e0) G  160 }

{   ,  }
  if ( L = K ) 
   then goto _50;
  T := A[(L-1)+(K-1)*M];
  A[(L-1)+(K-1)*M] := A[(K-1)+(K-1)*M];
  A[(K-1)+(K-1)*M] := T;
_50:

{     }
  T := -1.e0/A[(K-1)+(K-1)*M];
  J := N - K;
  I := (J Mod 5) + K;
  if ( I = K ) 
   then goto _70;
  for J:=KP1 to I do
   begin
    A[(J-1)+(K-1)*M] := T*A[(J-1)+(K-1)*M];
_60:
   end;
_70:
  I := I + 1;
  if ( I > N ) 
   then goto _90;
  J := I;
  while ( J<=N ) do
   begin
    A[(J-1)+(K-1)*M] := T*A[(J-1)+(K-1)*M];
    A[(J+1-1)+(K-1)*M] := T*A[(J+1-1)+(K-1)*M];
    A[(J+2-1)+(K-1)*M] := T*A[(J+2-1)+(K-1)*M];
    A[(J+3-1)+(K-1)*M] := T*A[(J+3-1)+(K-1)*M];
    A[(J+4-1)+(K-1)*M] := T*A[(J+4-1)+(K-1)*M];
_80:
    inc(J,5);
   end;
_90:

{     }
  for J:=KP1 to N do
   begin
    T := A[(L-1)+(J-1)*M];
    if ( L = K ) 
     then goto _100;
    A[(L-1)+(J-1)*M] := A[(K-1)+(J-1)*M];
    A[(K-1)+(J-1)*M] := T;
_100:
    JJ := N - K;
    I := (JJ Mod 4) + K;
    if ( I = K ) 
     then goto _120;
    for JJ:=KP1 to I do
     begin
      A[(JJ-1)+(J-1)*M] := A[(JJ-1)+(J-1)*M] + T*A[(JJ-1)+(K-1)*M];
_110:
     end;
_120:
    I := I + 1;
    if ( I > N ) 
     then goto _140;
    JJ := I;
    while ( JJ<=N ) do
     begin
      A[(JJ-1)+(J-1)*M] := A[(JJ-1)+(J-1)*M] + T*A[(JJ-1)+(K-1)*M];
      A[(JJ+1-1)+(J-1)*M] := A[(JJ+1-1)+(J-1)*M] + T*A[(JJ+1-1)+(K-1)*M];
      A[(JJ+2-1)+(J-1)*M] := A[(JJ+2-1)+(J-1)*M] + T*A[(JJ+2-1)+(K-1)*M];
      A[(JJ+3-1)+(J-1)*M] := A[(JJ+3-1)+(J-1)*M] + T*A[(JJ+3-1)+(K-1)*M];
_130:
      inc(JJ,4);
     end;
_140:
_150:
   end;
  goto _170;
_160:
  IERR := -K;
_170:
_180:
 end;
_190:
NLEAD[N-1] := N;
if ( A[(N-1)+(N-1)*M] = 0.0e0 ) 
 then IERR := -N;
if ( IERR = 0 ) 
 then goto _200;
UTAFSI('A','F','G','5','E',IERR);
_200:
end;

end.
